"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const start = process.hrtime();
const chalk_1 = require("chalk");
const commander = require("commander");
const debug = require("debug");
const leftpad = require("left-pad");
const run_1 = require("./commands/run");
// tslint:disable-next-line:no-var-requires
const pkg = require('../package.json');
const NS_PER_SEC = 1e9;
process.title = 'code-to-json';
let actionInvoked = false;
exports.debugLog = debug('code-to-json:cli');
const prog = commander
    .version(pkg.version)
    .name('code-to-json')
    .arguments('[entries...]')
    .description('a thing')
    .option('-p,--project [path]', 'path to tsconfig.json')
    .option('-o,--out <path>', 'output path')
    .action((entries, _command) => {
    actionInvoked = true;
    setTimeout(() => {
        const opts = _command.opts();
        const { project } = opts;
        const startupElapsed = process.hrtime(start);
        exports.debugLog(`${chalk_1.default.yellow(leftpad((Math.round((startupElapsed[0] * NS_PER_SEC + startupElapsed[1]) / 1e3) / 1e3).toFixed(3), 6))} ms ${chalk_1.default.green('(startup time)')}
`);
        const beginTime = process.hrtime();
        try {
            run_1.default(Object.assign({}, opts, { project }), entries);
        }
        catch (err) {
            if (err.__invalid_arguments_error) {
                process.stderr.write(chalk_1.default.red(`\n[ERROR] - ${err.message}\n`));
                process.stderr.write(prog.help() + '\n');
                process.exit(1);
            }
            else {
                throw err;
            }
        }
        const timeElapsed = process.hrtime(beginTime);
        exports.debugLog(`${chalk_1.default.yellow(leftpad((Math.round((timeElapsed[0] * NS_PER_SEC + timeElapsed[1]) / 1e3) /
            1e3).toFixed(3), 6))} ms ${chalk_1.default.green('(extraction time)')}
`);
    }, 0);
})
    .parse(process.argv);
if (!actionInvoked) {
    setTimeout(() => {
        process.stderr.write(prog.help() + '\n');
        process.exit(1);
    }, 0);
}
//# sourceMappingURL=index.js.map